$regfile = "attiny2313.dat"
$crystal = 8000000
$hwstack = 32
$swstack = 10
$framesize = 40

Config Portd = Output

Cs Alias Portd.1
Ser_clk Alias Portd.2
Ser_data Alias Portd.3

Dim A As Word
Dim Digit(8)as Byte
Dim Y As Byte
Dim Disp_num As Byte
Dim Disp_data As Byte
Dim Digit_str As String * 4
Dim Temp_str As String * 3
Gosub Max7219_setup

Digit_str = "Good"           '    
Gosub Prepare                '     

Wait 3

Do                           '       1 
Waitms 200
Incr A                       '     
Digit_str = Str(a)
Digit_str = Format(digit_str , "0000")
Gosub Prepare
Loop

End



'   
Prepare:
Do
For Y = 1 To 4
   Temp_str = Mid(digit_str , Y , 1)
   Select Case Temp_str
      Case "0" : Temp_str = "126"                           '&b01111110
      Case "1" : Temp_str = "48"                            '&b00110000
      Case "2" : Temp_str = "109"                           '&b01101101
      Case "3" : Temp_str = "121"                           '&b01111001
      Case "4" : Temp_str = "51"                            '&b00110011
      Case "5" : Temp_str = "91"                            '&b01011011
      Case "6" : Temp_str = "95"                            '&b01011111
      Case "7" : Temp_str = "112"                           '&b01110000
      Case "8" : Temp_str = "127"                           '&b01111111
      Case "9" : Temp_str = "123"                           '&b01111011
      Case "." : Temp_str = "128"                           '&b10000000
      '     
      Case "A" : Temp_str = "119"                           '&b01110111
      Case "C" : Temp_str = "78"                            '&b01001110
      Case "E" : Temp_str = "79"                            '&b01001111
      Case "G" : Temp_str = "94"                            '&b01011110
      Case "o" : Temp_str = "29"                            '&b00011101
      Case "d" : Temp_str = "61"                            '&b00111101
      Case " " : Temp_str = "0"                             '&b00000000
      '  ...
   End Select
   Digit(y) = Val(temp_str)

      Disp_num = Y             ' ()     

      Disp_data = Digit(y)     '     
      Gosub Disp_write
Next Y
Loop Until Y = 5    '     4     
Return



'   max7221
Disp_write:
Ser_data = 0
Ser_clk = 0
Cs = 0
Shiftout Ser_data , Ser_clk , Disp_num , 1   '  
Shiftout Ser_data , Ser_clk , Disp_data , 1  '    
Cs = 1
Return


' max7221
Max7219_setup:
Disp_num = &H0C : Disp_data = 0     ' Shutdown (0-, 1-)
Gosub Disp_write
Disp_num = &H09 : Disp_data = 0     '    
Gosub Disp_write
Disp_num = &H0A : Disp_data = 10    '   (0-, 15-)
Gosub Disp_write
Disp_num = &H0B : Disp_data = 3     '   (  0)
Gosub Disp_write
Disp_num = &H0F : Disp_data = 0     '   (0-, 1-)
Gosub Disp_write
Disp_num = &H0C : Disp_data = 1
Gosub Disp_write
Return